#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "event4xi.py">
#<abstract4xi abstract = "provides Event4Xi class"/>
#<refer4xi reference = "synchronize.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
#

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Event4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # imported-as ones 
    from time import time as _time, sleep as _sleep        
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from condition4xi import Condition4Xi
from lock4xi import Lock4Xi
from reason_object4xi import reason_object4xi
from register_after_fork4xi import register_after_fork4xi
from sense_object4xi import sense_object4xi
from timeout4xi import omega2timeout4xi
from print4xi import print4xi
from time4xi import time4xi    
#"
#/>

                

# =================================================================================================
#<class4xi class = "Event4Xi" base = "object" child = "None" synopsis = "offers services for events" usage = "
#     managers.py:
#         SyncManager.register('Event', threading.Event, EventProxy)
# 
#    syncmanager4xi.py:
#         SyncManager4Xi.register('Event4Xi', threading.Event, EventProxy4Xi)"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
      
class Event4Xi(object):
    '''
    Event4Xi class offers services for events  
    '''
  
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ( 'set', 'is_set', 'clear', 'wait', 'sense', 'reason', 'ace')         
    #"
    #/>
                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Event4Xi" usage = "initializes with( self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
        '''
        Event4Xi method __init__: initializes with( self) 
        '''
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/4)
        # -----------------------------------------------------------------------------------------
        class2print = "Event4Xi"
        method2print = "__init__"
        
        message2print = "{(Step 1/4a) started" + "; init-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        
        message2print = "{(Step 1/4b) borning" + "; event2xi-of-Event4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

        message2print = "{(Step 1/4c) inheriting" + "; object-inheriting-by-event2xi-of-Event4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        
            
                        
        # -----------------------------------------------------------------------------------------
        # (Step 2/4)
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2/4a) passing" + "; Lock4Xi-passing-to-Condition4Xi-by-is-set-of-Event4Xi: " + str(Lock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                 

        message2print = "{(Step 2/4b) calling" + "; Condition4Xi-calling-by-is-set-of-Event4Xi: " + str(Condition4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                        
   
        self._cond = Condition4Xi(Lock4Xi())

        message2print = "{(Step 2/4c) set" + "; cond-of-event2xi-set-by-init-of-Event4Xi to: " + str(self._cond)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/4)
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3/4a) passing" + "; zero-passing-to-SemaphoreXi-by-is-set-of-Event4Xi: " + str(0) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                        
        message2print = "{(Step 3/4b) calling" + "; SemaphoreXi-calling-by-is-set-of-Event4Xi: " + str(SemaphoreXi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                        
        self._flag = SemaphoreXi(0)
     
        message2print = "{(Step 3/4c) set" + "; flag-of-event2xi-set-by-init-of-Event4Xi to: " + str(self._flag)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                   
                        
        # -----------------------------------------------------------------------------------------
        # (Step 4/4)
        # -----------------------------------------------------------------------------------------
           
        message2print = "{(Step 4/4a) activated" + "; event2xi-of-Event4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
         
        message2print = "{(Step 1/4b) inherited" + "; object-inherited-by-event2xi-of-Event4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{(Step 4/4c) returning" + "; init-of-Event4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
                
                                   
    #</methodize4xi>
                        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "is-set-of-Event4Xi" usage = "sets with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def is_set(self):
        '''
        Event4Xi method is_set: sets with (self)
        '''
        # -----------------------------------------------------------------------------------------
        # (Step 1/5)
        # -----------------------------------------------------------------------------------------    
        class2print = "Event4Xi"
        method2print = "is_set"
        
        message2print = "{(Step 1/5) started" + "; is-set-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

    
        # -----------------------------------------------------------------------------------------
        # (Step 2/5)
        # -----------------------------------------------------------------------------------------        
        self._cond.acquire()
        
        message2print = "{(Step 2/5) performed" + "; cond-acquire-of-event2xi-performed-by-is-set-of-Event4Xi: " + str(self._cond.acquire) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                     
        setstatus2xi = False
        
        try:
            if self._flag.acquire(False):
            
                # ---------------------------------------------------------------------------------
                # (Step 3/5)
                # ---------------------------------------------------------------------------------             
            
                self._flag.release()

                message2print = "{(Step 3/5) performed" + "; flag-release-of-event2xi-performed-by-is-set-of-Event4Xi: " + str(self._flag.release) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             

                setstatus2xi = True
            

        finally:
            # -------------------------------------------------------------------------------------
            # (Step 4/5)
            # -------------------------------------------------------------------------------------              
            self._cond.release()

            message2print = "{(Step 4/5) performed" + "; cond-release-of-event2xi-performed-by-is-set-of-Event4Xi: " + str(self._cond.release) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                                        

        # -----------------------------------------------------------------------------------------
        # (Step 5/5)
        # -----------------------------------------------------------------------------------------                     
        message2print = "{returning" + "; setstatus2xi-returning-by-is-set-of-Event4Xi: " + str(setstatus2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
          
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-of-Event4Xi" usage = "sets with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def set(self):
        '''
        Event4Xi method set: sets with (self)
        '''
        # -----------------------------------------------------------------------------------------
        # (Step 1/5)
        # -----------------------------------------------------------------------------------------    
        class2print = "Event4Xi"
        method2print = "set"
        
        message2print = "{(Step 1/5) started" + "; set-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    
        # -----------------------------------------------------------------------------------------
        # (Step 2/5)
        # -----------------------------------------------------------------------------------------         
        
        self._cond.acquire()
        
        message2print = "{(Step 2/5) performed" + "; cond-acquire-of-event2xi-performed-by-set-of-Event4Xi: " + str(self._cond.acquire) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                  
        
        try:
            # -------------------------------------------------------------------------------------
            # (Step 3/5)
            # -------------------------------------------------------------------------------------         
          
            self._flag.acquire(False)
        
            message2print = "{(Step 3/5a) performed" + "; flag-acquire-of-event2xi-performed-by-set-of-Event4Xi: " + str(self._flag.acquire) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            
            
            self._flag.release()
        
            message2print = "{(Step 3/5b) performed" + "; flag-release-of-event2xi-performed-by-set-of-Event4Xi: " + str(self._flag.release) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            
            
            self._cond.notify_all()
        
            message2print = "{(Step 3/5c) performed" + "; cond-notify_all-of-event2xi-performed-by-set-of-Event4Xi: " + str(self._cond.notify_all) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
             


        finally:
            # -------------------------------------------------------------------------------------
            # (Step 4/5)
            # -------------------------------------------------------------------------------------         
          
            self._cond.release()
            
        
            message2print = "{performed" + "; cond.release-of-event2xi-performed-by-set-of-Event4Xi: " + str(self._cond.release) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
  
    
        # -----------------------------------------------------------------------------------------
        # (Step 5/5)
        # -----------------------------------------------------------------------------------------         
        message2print = "{(Step 5/5) returning" + "; set-of-Event4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                           
                   
                           
    #</methodize4xi>
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "clear-of-Event4Xi" usage = "clears with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def clear(self):
        '''
        Event4Xi method clear: clears with (self)
        '''
        # -----------------------------------------------------------------------------------------
        # (Step 1/5)
        # -----------------------------------------------------------------------------------------    
        class2print = "Event4Xi"
        method2print = "clear"
        
        message2print = "{(Step 1/5) started" + "; clear-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    
        # -----------------------------------------------------------------------------------------
        # (Step 2/5)
        # ----------------------------------------------------------------------------------------- 
        self._cond.acquire()

        message2print = "{(Step 2/5) performed" + "; cond-acquire-of-event2xi-performed-by-clear-of-Event4Xi: " + str(self._cond.acquire) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                           
        
        try:
            # -------------------------------------------------------------------------------------
            #(Step 3/5)
            # -------------------------------------------------------------------------------------         
            self._flag.acquire(False)

            message2print = "{(Step 3/5) performed" + "; flag-acquire-of-event2xi-performed-by-clear-of-Event4Xi: " + str(self._flag.acquire) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                 

        finally:
            # -------------------------------------------------------------------------------------
            #(Step 4/5)
            # -------------------------------------------------------------------------------------           
            self._cond.release()

            message2print = "{(Step 4/5) performed" + "; cond-release-of-event2xi-performed-by-clear-of-Event4Xi: " + str(self._cond.release) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
               

        # -----------------------------------------------------------------------------------------
        #(Step 5/5)
        # -----------------------------------------------------------------------------------------         
        message2print = "{(Step 5/5) returning" + "; clear-of-Event4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                       
    #</methodize4xi>
    
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "wait-of-Event4Xi" usage = "waits with (self, timeout) ">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def wait(self, timeout=None):
        '''
        Event4Xi method wait: waits with (self, timeout) 
        '''
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/5)
        # -----------------------------------------------------------------------------------------    
        class2print = "Event4Xi"
        method2print = "wait"
        
        message2print = "{(Step 1/5a) started" + "; wait-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        timeout = omega2timeout4xi(class2print, method2print) 

        message2print = "{(Step 1/5b) set" + "; timeout-set-by-wait-of-Event4Xi to: " + str(timeout)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/5)
        # -----------------------------------------------------------------------------------------       
        
        self._cond.acquire()
     
        message2print = "{(Step 2/5) performed" + "; cond-acquire-of-event2xi-performed-by-wait-of-Event4Xi: " + str(self._cond.acquire) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
        try:
        
            # -------------------------------------------------------------------------------------
            # (Step 3/5)
            # -------------------------------------------------------------------------------------       
            
            if self._flag.acquire(False):
                self._flag.release()
     
                message2print = "{(Step 3/5a) performed" + "; flag-release-of-event2xi-performed-by-wait-of-Event4Xi: " + str(self._flag.release) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                   

            else:
                self._cond.wait(timeout)
     
                message2print = "{(Step 3/5b) performed" + "; cond-wait-of-event2xi-performed-by-wait-of-Event4Xi: " + str(self._cond.wait) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                   
                
        finally:
        
            # -------------------------------------------------------------------------------------
            # (Step 4/5)
            # -------------------------------------------------------------------------------------       
             
            self._cond.release()
            
     
            message2print = "{(Step 4/5) performed" + "; cond-release-of-event2xi-performed-by-wait-of-Event4Xi: " + str(self._cond.release) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
             
        
        # -----------------------------------------------------------------------------------------
        # (Step 5/5)
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 5/5) returning" + "; wait-of-Event4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                        
    #</methodize4xi>
                                            
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Event4Xi" usage = "senses Event4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Event4Xi class objects
        '''
          
        
        class2print = 'Event4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; event4xi-sensing-by-sense-of-Event4Xi: " + str(Event4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                      
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Event4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-event2xi'] = object
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-Event4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        
      
        message2print = "{sensed" + "; event4xi-sensed-by-sense-of-Event4Xi: " + str(Event4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Event4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Event4Xi" usage = "reasons Event4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Event4Xi class objects
        '''
                
        
        class2print = 'Event4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Event4Xi-reasoning-by-reason-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-Event4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; Event4Xi-reasoned-by-reason-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Event4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                              
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Event4Xi" usage = "aces Event4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Event4Xi class objects 
        '''
                
        
        
        class2print = 'Event4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-Event4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Event4Xi-acing-by-ace-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Event4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; Event4Xi-aced-by-ace-of-Event4Xi: " + str(Event4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Event4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                           
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of event4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

